#include <avr/io.h>
#include <util/delay.h>

#define data_port PORTA

 //structure to allow bit field operations, name conversions: PORTA.0 -> PORT_A.b0  PORTB.7 -> PORT_B.b7
typedef struct{ uint8_t b0:1;
                uint8_t b1:1;
                uint8_t b2:1;
                uint8_t b3:1;
                uint8_t b4:1;
                uint8_t b5:1;
                uint8_t b6:1;
                uint8_t b7:1; } bits;

// define all the ports of your microcontroller, add more ports depending on the available mcu ports
#define PORT_A (* (volatile bits *) &PORTA)
#define PIN_A (* (volatile bits *) &PINA)
#define DDR_A (* (volatile bits *) &DDRA)
 
#define PORT_B (* (volatile bits *) &PORTB)
#define PIN_B (* (volatile bits *) &PINB)
#define DDR_B (* (volatile bits *) &DDRB)

#define PORT_C (* (volatile bits *) &PORTC)
#define PIN_C (* (volatile bits *) &PINC)
#define DDR_C (* (volatile bits *) &DDRC)
//LCD control on PORT C
#define en  PORT_C.b0
#define rs  PORT_C.b1
#define rw  PORT_C.b2

void test(unsigned char data1);

void lcd_command(unsigned char command)
{
	data_port = command;
	
	en = 1;
	_delay_us(10);
	rs = 0;
	_delay_us(50);
	rw = 0;
	_delay_us(80);
	en = 0;
	
	
}

void lcd_data(uint8_t disp)    // function to send data on LCD
{
	data_port=disp;
	en = 1;
	rs = 1;
	rw = 0;
	_delay_ms(50);
	en = 0;
}

void lcd_dataa(uint8_t *disp)    // function to send string to LCD
{
	int x;
	for(x=0;disp[x]!=0;x++)
	{
		lcd_data(disp[x]);

	}
}

lcd_ini()     //Function to inisialize the LCD
	{
		lcd_command(0x30);//power up LCD 
		_delay_ms(50);
		lcd_command(0x38);   
		_delay_ms(50);
		lcd_command(0x0F);       
		_delay_ms(50);
		lcd_command(0x80);
		_delay_ms(50);
	  
	}
int main (void)
{
  	
	DDRC = 0xFF;
	
	DDRA = 0xFF;
	
	lcd_ini();
  while(1)
    {
		
		
		lcd_command(0x00);
   		_delay_ms(10); //delay
		lcd_command(0x01);
		_delay_ms(10); //delay
		lcd_data(0x01);
		_delay_ms(10); //delay
		lcd_data(0x00);
	    
		lcd_dataa("AVR ATMEGA128");
        
		
		
        

    }
}
